unit Http;

interface

uses
    Windows, SysUtils, Classes, WinSock;

procedure SendGetCommandToHost(const host, page: string; s: TStream);

implementation

//-----------------------------------------------------------------------------
//  IPAhX`̕񂩂ǂ𒲂ׂ
function IsIpText(const s: string): Boolean;

    function IsByteText(const str: string): Boolean;
    var
        j: integer;
    begin
        //  `FbN
        if not TryStrToInt(str, j) then Result := false
        //  `FbN-2
        else if (j < 0) or (255 < j) then Result := false
        //  ʂ
        else Result := true;
    end;

var
    l1, l2: integer;
    t, t1: string;
begin
    Result := false;

    //  sIhɁA񒷂3ւȂƂ
    l1 := Length(s);
    l2 := Length(StringReplace(s, '.', '', [rfReplaceAll]));
    if (l1 <> l2 + 3) then Exit;

    //  ŏ̐
    t := s;
    t1 := Copy(t, 1, Pos('.', t) - 1);

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  2Ԗڂ̐
    Delete(t, 1, Length(t1) + 1);
    t1 := Copy(t, 1, Pos('.', t) - 1);

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  3Ԗڂ̐
    Delete(t, 1, Length(t1) + 1);
    t1 := Copy(t, 1, Pos('.', t) - 1);

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  4Ԗڂ̐
    Delete(t, 1, Length(t1) + 1);
    t1 := t;

    //  `FbN
    if not IsByteText(t1) then Exit;

    //  ʂ
    Result := true;
end;

//-----------------------------------------------------------------------------
// IPAhXzXgIPAhXłԂ
// http://www.asahi-net.or.jp/~nk2w-ishr/winsock3.htm
function GetInetAddr(s: string): integer;
var
    ip : u_long;
    phe: PHostEnt;
begin
    phe := nil;

    //  10i\L̏ꍇ
    if IsIpText(s) then
    begin
        ip := inet_addr(PChar(s));
        if (ip <> INADDR_NONE) then phe := gethostbyaddr(@ip, 4, AF_INET);
    end
    //  zXg\L̏ꍇ
    else
    begin
        phe := gethostbyname(PChar(s))
    end;

    //  ߂
    if not Assigned(phe) then
    begin
        raise Exception.Create(Format('[%s] IS INVALID ADDRSS.', [s]));
    end;

    //  ł֕ϊ
    Result := inet_addr(inet_ntoa(PInAddr(phe^.h_addr_list^)^));
end;

//-----------------------------------------------------------------------------
//  T[o[ւGETR}hoƕԎ擾
//  C/C++300̋Z(P36)
//  http://www.asahi-net.or.jp/~nk2w-ishr/winsock4.htm
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm
procedure SendGetCommandToHost(const host, page: string; s: TStream);
var
    GetCommand: string;
    sock: TSocket;
    sockaddr: TSockAddr;
    sendlen: integer;
    recvlen: integer;
    recvdata: array[0..1024] of Char;
    temp: string;
    i: integer;
begin
    try
        //  WEBT[o֑M閽
        GetCommand := Format('GET %s HTTP/1.0'#13#10#13#10, [page]);

        //  \Pbg쐬
        sock := socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

        //  ꂽH
        if sock = INVALID_SOCKET then
        begin
            raise Exception.Create(SysErrorMessage(GetLastError()));
        end;

        //  ڑ̃AhXE|[gw
        FillChar(sockaddr, SizeOf(TSockAddr), #0);
        sockaddr.sin_family      := AF_INET;
        sockaddr.sin_port        := htons(80);
        sockaddr.sin_addr.S_addr := GetInetAddr(host);

        //  ڑ
        if connect(sock, sockaddr, sizeof(sockaddr)) = SOCKET_ERROR then
        begin
            closesocket(sock);
            raise Exception.Create(SysErrorMessage(GetLastError()));
        end;

        //  M
        sendlen := send(sock, GetCommand[1], length(GetCommand), 0);
        if sendlen = SOCKET_ERROR then
        begin
            closesocket(sock);
            raise Exception.Create(SysErrorMessage(GetLastError()));
        end;

        //  M
        while True do
        begin
            //  
            FillChar(recvdata, SizeOf(recvdata), #0);

            //  󂯂Ă݂
            recvlen := recv(sock, recvdata, Length(recvdata), 0);

            //  G[ȂI
            if recvlen = SOCKET_ERROR then break;

            //  ȂI
            if recvlen = 0 then break;

            //  s2AŒf
            i := AnsiPos(#13#10#13#10, recvdata);
            if (i > 0) then
            begin
                //  s
                temp := recvdata;
                temp := Copy(temp, 1, i - 1);

                //  
                s.Write(temp[1], Length(temp));

                //  I
                break;
            end
            else
            begin
                //  
                s.Write(recvdata, recvlen);
            end;
        end;

        // ߂
        s.Position := 0;

        // \Pbg̔j
        closesocket(sock);
    except
        on E:Exception do
        begin
            raise Exception.Create(E.Message);
        end;
    end;
end;


//-----------------------------------------------------------------------------
//  WinSock
var
    ad: TWSAData;

initialization
    WSAStartup($0101, ad);

//-----------------------------------------------------------------------------
//  n
finalization
    WSACleanup();

end.
